#include <iostream>
#include <fstream>
#include "amp.h"

int main( int argc, char** argv )
{
        //Default Values for inputs
        cld smear = 0.l;
        cld photo1 = .7071l;
        cld photo2 = .7071l;
        cld jp = -1.5l;
        cld r1 = -1l;
        cld r2 = -1l;
        int plot = 0;

        for (int ii=0; ii<argc; ii++)
        {
                if (strcmp(argv[ii],"-p_n")==0) photo1 = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-s")==0) smear = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-j")==0) jp = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-r_n")==0) r1 = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-r_w")==0) r2 = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-p_w")==0) photo2 = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-plot")==0) plot = 1;
        }

        //Grabs INPUTS
        cld input[17];
        get_inputs(jp, input);

        if (real(r1) >= 0)
        {
                input[5] = r1;
        }
        if (real(r2) >= 0)
        {
                input[9] = r2;
        }

        input[16] = smear;
        input[14] = photo1;
        input[15] = photo2;

        cld amplitudes[24];
        cld output[5];
        cld egam;
        cld ccos;

        // ofstream two_dim;
        // two_dim.open("./output/2d.dat");
        // two_dim << left << setw(30) << "#Background, A_norm:" << setw(20) << real(input[2]) << endl;
        // two_dim << left << setw(30) << "#Pc(4380) spin/parity: " << setw(20) << real(input[12]) << endl;
        // two_dim << left << setw(30) << "#     BR:" << setw(20) << real(input[9]) << endl;
        // two_dim << left << setw(30) << "#     Photocouplings: " << setw(20) << real(input[15]) << endl;
        // two_dim << left << setw(30) << "#Pc(4450) spin/parity: " << setw(20) << real(input[8]) << endl;
        // two_dim << left << setw(30) << "#     BR:" << setw(20) << real(input[5]) << endl;
        // two_dim << left << setw(30) << "#     Photocouplings: " << setw(20) << real(input[14]) << endl;
        // two_dim << left << setw(30) << "#Smearing, sigma_s: " << setw(5) << real(input[9]) << "GeV" << endl;
        // two_dim << left << setw(30) << "" << endl;
        // two_dim << left << setw(30) << "#Egamma" << setw(30) << "Cos" << setw(30)
        //         << "KLL" << setw(30) << "ALL"
        //
        //         //     << "Re[rho11]" << setw(30) << "Im[rho11]" << setw(30) << "Re[rho10]" << setw(30) <<
        //         // "Im[rho10]" << setw(30) <<  "Re[rho1-1]" << setw(30) <<  "Im[rho1-1]"
        //
        //         << endl;
        // input[9] = 0;
        // input[5] = 0;
        // egam = 10.0831;
        // cos = 1.;
        // for (int a = 0; a < 20; a++)
        // {
        //         input[5] = a*0.01;
        //         for (int b = 0; b < 21; b++ )
        //         {
        //                 input[9] = b*0.01;
        //                 ObservablesParam(egam, cos, input, output);
        //                 two_dim << left << setw(30) << real(input[5]) << setw(30) << real(input[9]) << setw(30)
        //                         << real(output[1]) << setw(30) << real(output[2])
        //
        //                         //  << real(output[2]) << setw(30) << imag(output[2]) << setw(30) << real(output[3]) << setw(30) << imag(output[3])
        //                         // << setw(30) << real(output[4]) << setw(30) << imag(output[4]) << setw(30)  //SDMEs
        //
        //                         << endl;
        //
        //         }
        // }
        // two_dim.close();

        double accos;
        ofstream two_dim;
        two_dim.open("./output/2d.dat");
        egam = 10.0831;
        for (int a = 0; a < 201; a++)
        {
                accos = 0. + .45*a;
                ccos = cos(accos*3.14159/180.);
                for (int b = 0; b < 26; b++)
                {
                        input[14] = 0 + b*.04;
                        ObservablesParam(egam, ccos, input, output);
                        two_dim << left << setw(30) << accos << setw(30) << real(input[14]) << setw(30)
                                << real(output[1]) << setw(30) << real(output[2]) << endl;
                }
        }
        two_dim.close();

        if (plot == 1)
        {
                // system("mkdir -p ./output/plots && gnuplot ./src/gnuplot/quick-plot-2d.p");
                system("mkdir -p ./output/plots && gnuplot ./src/gnuplot/angle-vs-photo.gnu");
        }
        return 0;
}
