#include <iostream>
#include <fstream>
#include "amp.h"

int main( int argc, char** argv )
{
        //Default Values for inputs
        cld cos = 1.l;
        cld stepsize = .01l;
        cld smear = 0.l;
        cld photo1 = .7071l;
        cld jp = -1.5l;
        cld r1 = -1;
        cld r2 = -1;
        cld maxe = 22.l;
        cld photo2 = .7071l;
        int plot = 0;

        for (int ii=0; ii<argc; ii++)
        {
                if (strcmp(argv[ii],"-c")==0) cos = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-b")==0) stepsize = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-p_n")==0) photo1 = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-s")==0) smear = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-j")==0) jp = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-r_n")==0) r1 = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-r_w")==0) r2 = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-m")==0) maxe = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-p_w")==0) photo2 = atof(argv[ii+1]);
                if (strcmp(argv[ii],"-plot")==0) plot = 1;
        }

        //Grabs INPUTS
        cld input[17];
        get_inputs(jp, input);

        if (real(r1) >= 0)
        {
                input[5] = r1;
        }
        if (real(r2) >= 0)
        {
                input[9] = r2;
        }

        input[16] = smear;
        input[14] = photo1;
        input[15] = photo2;

        cld amplitudes[24];
        cld output[5];
        cld egam;

        //Energy Dependance
        ofstream const_angle;
        const_angle.open("./output/fixed-angle.dat");
        const_angle << "#Fixed Cosine of Scattering Angle = " << real(cos) << endl;
        const_angle << left << setw(30) << "#Background, A_norm:" << setw(20) << real(input[2]) << endl;
        const_angle << left << setw(30) << "#Pc(4380) spin/parity: " << setw(20) << real(input[12]) << endl;
        const_angle << left << setw(30) << "#   BR:" << setw(20) << real(input[9]) << endl;
        const_angle << left << setw(30) << "#   Photocoupling ratio: " << setw(20) << real(input[15]) << endl;
        const_angle << left << setw(30) << "#Pc(4450) spin/parity: " << setw(20) << real(input[8]) << endl;
        const_angle << left << setw(30) << "#   BR:" << setw(20) << real(input[5]) << endl;
        const_angle << left << setw(30) << "#   Photocoupling ratio: " << setw(20) << real(input[14]) << endl;
        const_angle << left << setw(30) << "#Smearing, sigma_s: " << setw(5) << real(input[16]) << "GeV" << endl;
        const_angle << left << setw(30) << "" << endl;
        const_angle << left << setw(30) << "#Egamma" << setw(30) << "DXS [nb GeV^-2]" << setw(30)
                    << "KLL" << setw(30) << "ALL"

                //     << "Re[rho11]" << setw(30) << "Im[rho11]" << setw(30) << "Re[rho10]" << setw(30) <<
                // "Im[rho10]" << setw(30) <<  "Re[rho1-1]" << setw(30) <<  "Im[rho1-1]"

                    << endl;

        for (int a = 0; a < int(real((maxe-8.3l)/stepsize)) + 1; a++)
        {
                egam = 8.3l + cld(a)*stepsize;
                ObservablesParam(egam, cos, input, output);
                const_angle << left << setw(30) << real(egam) << setw(30) << real(output[0]) << setw(30)
                            << real(output[1]) << setw(30) << real(output[2])

                        //  << real(output[2]) << setw(30) << imag(output[2]) << setw(30) << real(output[3]) << setw(30) << imag(output[3])
                        // << setw(30) << real(output[4]) << setw(30) << imag(output[4]) << setw(30)  //SDMEs

                            << endl;

        }
        const_angle.close();

        if (plot == 1)
        {
                system("mkdir -p ./output/plots && gnuplot ./src/gnuplot/quick-plot-energy.p");
        }

        return 0;
}
