set term pdf color enhanced font "Helvetica,12"
#set auto
#set border 15 lw 1
#set size 0.5, 0.5

set view map
#set dgrid3d 100,1000,1


#set pm3d interpolate 0,0

set out "./output/plots/2D-BRBR.pdf"
set xrange [-0.01: 0.2]
set yrange [-.01: .21]
set palette defined (0 0 0 0.5, 1 0 0 1, 2 0 0.5 1, 3 0 1 1, 4 0.5 1 0.5, 5 1 1 0, 6 1 0.5 0, 7 1 0 0, 8 0.5 0 0)

if (!exists("MP_LEFT"))   MP_LEFT = 0.13
if (!exists("MP_RIGHT"))  MP_RIGHT = 0.87
if (!exists("MP_BOTTOM")) MP_BOTTOM = .17
if (!exists("MP_TOP"))    MP_TOP = .87
if (!exists("MP_GAP"))    MP_GAP = 0.05

set multiplot layout 1,2 columnsfirst \
        margins screen MP_LEFT, MP_RIGHT, MP_BOTTOM, MP_TOP spacing screen MP_GAP



        set xlabel "BR Pc(4450)" offset 18,0,0
        set ylabel "BR Pc(4380)"
        unset colorbox
        set title "0°"
splot "./output/2d-0.dat" u 1:2:3 t "" w points pointtype 4 pointsize 1 palette linewidth 14
#splot "./output/2d-0.dat" u 1:2:4 t "" w points pointtype 4 pointsize 1 palette linewidth 14
unset ylabel
unset ytics
unset xlabel
set colorbox
set title "45°"
splot "./output/2d-45.dat" u 1:2:3 t "" w points pointtype 4 pointsize 1 palette linewidth 14
#splot "./output/2d-45.dat" u 1:2:4 t "" w points pointtype 4 pointsize 1 palette linewidth 14
