#include <iostream>
#include <fstream>
#include "amp.h"

int main(int argc, char** argv)
{
		cld egam = 652.l;
		cld jp= -2.5l;
		cld r1= -1l;
		cld r2 = -1l;
		cld smear = 0.l;
		int plot = 0;
		for (int ii=0; ii<argc; ii++)
		{
				if (strcmp(argv[ii],"-e")==0) egam = atof(argv[ii+1]);
				if (strcmp(argv[ii],"-r_n")==0) r1 = atof(argv[ii+1]);
				if (strcmp(argv[ii],"-r_w")==0) r2 = atof(argv[ii+1]);
				if (strcmp(argv[ii],"-s")==0) smear = atof(argv[ii+1]);
				if (strcmp(argv[ii],"-test")==0) jp = 100.;
				if (strcmp(argv[ii],"-plot")==0) plot = 1;
		}
		//Grabs INPUTS
		cld input[17];
		get_inputs(jp, input);

		if (real(r1) >= 0)
		{
				input[5] = r1;
		}
		if (real(r2) >= 0)
		{
				input[9] = r2;
		}

		input[16] = smear;
		cld amplitudes[24];
		cld output[5];
		cld cos;
		cld stepsize;
		cld bounds[2];

		get_cos_bounds(egam, bounds);

		stepsize = abs(bounds[0] - bounds[1])/100.l;

		//Angular Dependance
		ofstream const_energy;
		const_energy.open("./output/highenergy.dat");
		const_energy << left << setw(30) <<  "t" << setw(30) << "DXS [nb GeV^-2]" << setw(30) << "Egam [GeV]"

		                //      << "Re[rho11]" << setw(30) << "Im[rho11]" << setw(30) << "Re[rho10]" << setw(30) <<
		                // "Im[rho10]" << setw(30) <<  "Re[rho1-1]" << setw(30) <<  "Im[rho1-1]"

		             << endl;

		for (int a = 0; a < 100; a++)
		{
				cos = bounds[1] - cld(a)*stepsize;
				cld t = t_mand(egam, cos);
				ObservablesParam(egam, cos, input, output);
				const_energy << left << setw(30) << real(t) << setw(30)  << real(output[0])  <<  setw(30) << real(egam) << endl;
		}
		const_energy.close();

		if (plot == 1)
		{
				system("mkdir -p ./output/plots && gnuplot ./src/gnuplot/quick-plot-log.p");
		}
		return 0;
}
